#ifndef __HASH_TABLE_H__
#define __HASH_TABLE_H__

#include "student.h"

#define TABLE_SIZE 113

/**
 * Hash Entry for a student.
 */
typedef struct _HashEntry {
	struct _Student student;	// Student Information
	struct _HashEntry *next;	// THe next entry in the list
} HashEntry;


/**
 * Hash table
 */
typedef struct _HashTable {
	struct _HashEntry *hashTable[TABLE_SIZE];	// The hash table of students
	int sizes[TABLE_SIZE];						// Used for finding the size of each entry in the hash table
} HashTable;

/**
 * Index type
 */
typedef unsigned int Index;

// Initialize the hash table
void initTable(HashTable *table);
// Destroy the hash table
void destroyTable(HashTable * table);
// Insert a new entry in the hash table
void insertEntry(HashTable *table, Student *student);
// Delete an entry from the hash table
void deleteEntry(HashTable *table, const char *studentID);
// Find a student in the hash table
HashEntry *findEntry(HashTable *table, const char *studentID);
// Our Hash Function.
// Returns a value in the range [0, TABLE_SIZE)
Index hashFunction(const char *str);

#endif //__HASH_TABLE_H__