#include <stdio.h>
#include <stdlib.h>
#include "HashTable.h"

int main(void)
{
	HashTable table;
	Student st;
	char fName[256];
	char lName[256];
	char id[256];
	int i = 0;
	HashEntry *entry = NULL;
	char *myID = "999999";
	

	// Initialize the Hash Table
	initTable(&table);

	// Insert a student
	initStudent(&st, "Panayiotis", "Charalambous", myID);
	insertEntry(&table, &st);

	// Insert 10000 randomly names students
	for (i = 0; i < 10000; ++i) {
		sprintf(fName, "Panayiotis_%05d", i);
		sprintf(lName, "Panayiotou_%05d", i);
		sprintf(id, "%06d", rand() % 1000000);
		
		initStudent(&st, fName, lName, id);
		insertEntry(&table, &st);
	}

	// Print bin bin sizes
	fprintf(stdout, "idx\tsize\n");
	for (i = 0; i < TABLE_SIZE; ++i) {
		fprintf(stdout, "%d\t%d\n", i, table.sizes[i]);
	}
	fprintf(stdout, "\n\n");

	// Sanity check: find myself
	entry = findEntry(&table, myID);
	if (entry) {
		fprintf(stdout, "Entry with id %s found: ", myID);
		fprintf(stdout, "%s %s\n", entry->student.firstName, entry->student.lastName);
	}
	else {
		fprintf(stdout, "Entry with id %s was not found!!!", myID);
	}

	// Delete myself
	deleteEntry(&table, myID);

	// Sanity check: find myself
	entry = findEntry(&table, myID);
	if (entry) {
		fprintf(stdout, "Entry with id %s found: ", myID);
		fprintf(stdout, "%s %s\n", entry->student.firstName, entry->student.lastName);
	}
	else {
		fprintf(stdout, "Entry with id %s was not found!!!\n", myID);
	}

	// Delete the table
	destroyTable(&table);


	return 0;
}